/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

/**
 *
 * @author bar
 */
class DBManager{
    private DataSource source;
    
    public DBManager(DataSource source){
        this.source = source;
    }

    public void addFriend(String name, String surname){
        Connection con = null;
        try{
           con = source.getConnection();
           int id = getMaxId(con);

           PreparedStatement insert = con.prepareStatement("insert into APP.KAMARADI values(?,?,?)");

           insert.setInt(1, ++id);
           insert.setString(2, name);
           insert.setString(3,surname);
           insert.executeUpdate();
        }catch(SQLException ex){
            System.err.println("Problem pri pridani kamarada.");
        }finally{
            if( con != null ){
                try{
                    con.close();
                }catch(SQLException ex){
                    con = null;
                }
            }
        }
    }

    public List<Friend> getAllFriends(){
        List<Friend> result = new ArrayList<Friend>();
        try {
            Connection con = source.getConnection();
            Statement getAll = con.createStatement();
            ResultSet friends = getAll.executeQuery("select * from APP.KAMARADI");

            while(friends.next()){
                String name = friends.getString("jmeno");
                String sname = friends.getString("prijmeni");
                Friend friend = new Friend(name,sname);
                result.add(friend);
            }

        } catch (SQLException ex) {
            Logger.getLogger(DBManager.class.getName()).log(Level.SEVERE, null, ex);
        }
        return result;
    }

    private int getMaxId(Connection con) throws SQLException {
        int result = -1;
        Statement sel = con.createStatement();
        ResultSet res = sel.executeQuery("select max(id) from APP.KAMARADI");
        while(res.next()){
            result = res.getInt(1);
        }
        return result;
    }
}
class KamaradiDataSource implements DataSource{

    public Connection getConnection() throws SQLException {
        return DriverManager.getConnection("jdbc:derby://localhost:1527/friends","admin","admin");
    }

    public Connection getConnection(String username, String password) throws SQLException {
        return DriverManager.getConnection("jdbc:derby://localhost:1527/friends",username, password);
    }

    public PrintWriter getLogWriter() throws SQLException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setLogWriter(PrintWriter out) throws SQLException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setLoginTimeout(int seconds) throws SQLException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public int getLoginTimeout() throws SQLException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> T unwrap(Class<T> iface) throws SQLException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
public class FriendsServlet extends HttpServlet {

    private DBManager manager;

   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    }

    @Override
    public void init(ServletConfig servletConfig){
        manager = new DBManager(new KamaradiDataSource());
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        String name = request.getParameter("jmeno");
        String sname = request.getParameter("prijmeni");
        manager.addFriend(name,sname);

        List<Friend> friends = manager.getAllFriends();
        request.setAttribute("friends", friends);
        request.getRequestDispatcher("./results.jsp").forward(request, response);

    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
